// This is Not Tested , Use At Your Own Risk !

//+---------------------------------------------------------------------+
//| AR_lib_std.mqh for Arizona_Rules_5_v0.4b.mq4                        |
//|   Copyright  2011, RRJ                                             |
//|     http://kamome.2ch.net/test/read.cgi/livemarket2/1304547533/     |
//|                                                                     |
//|   Copyright  2009  Rob Booker & Bradley Fried                      |
//|                                                                     |
//|   Copyright  2006, Rob Booker. All rights reserved.                |
//|     http://www.theforexvillage.com/images/eBooks/TradingStrategies/robbooker_arizona_rules.pdf
//|         No part of this publication may be sold, distributed in any |
//|         form at any price (even free), or changed without the       |
//|         author's consent.                                           |
//+== Special Thanks ===================================================+
//|                                                          Stodiv.mq4 |
//|                         Copyright  2005-2006, RickD                |
//|                                           http://e2e-fx.net         |
//+---------------------------------------------------------------------+
//|                                               Linear Regression.mq4 |
//|                   Copyright  2006, tageiger, aka fxid10t@yahoo.com |
//|                                           http://www.metaquotes.net |
//+---------------------------------------------------------------------+

//----------------------------------------------------------------------

#define FONT        "Arial"

    //-- Method ----------------------------
#define Mesa            0   // Method : Mesa            
#define Scottsdale      1   // Method : Scottsdale      
#define Gilbert         2   // Method : Gilbert         
#define Divergence      3   // Method : Divergence      
#define Winslow         4   // Method : Winslow 
#define Sunbird         5   // Method : Sunbird         
#define Tombstone       6   // Method : Tombstone 
#define Surprise_trade  7   // Method : Surprise trade 
#define Stacking        8   // Method : Stacking 
#define Hidden_Diver    9   // Method : Hidden Divergence

double  dFasterMA0, dFasterMA1, dFasterMA2;
double  dMediumMA0, dMediumMA1;
double  dSlowerMA0, dSlowerMA1;

bool    bUp;

//-- AR Display function -----------------------------------------------
void PutDisp( int i, string sDisp )
{
    string  sName   = SHORT_NAME + "Info" + i;

    ObjectCreate( sName, OBJ_LABEL,0,0,0);
    ObjectSetText(sName, sDisp, 8, FONT, White);
    ObjectSet   ( sName, OBJPROP_CORNER,     0);
    ObjectSet   ( sName, OBJPROP_XDISTANCE, 20);
    ObjectSet   ( sName, OBJPROP_YDISTANCE, 12 * i);
}


//-- Custom indicator deinitialization function ------------------------
void DeleteTimeObject()
{
    //-- \bh炷ׂẴIuWFNg擾č폜
    for (int i=ObjectsTotal(); i>=0; i--) {
        string ObjName  = ObjectName(i);
        if ( (StringSubstr(ObjName,0,3) == "GN_"    )
          || (StringSubstr(ObjName,0,3) == SHORT_NAME) 
          || (StringSubstr(ObjName,0,3) == "HL_"    ) 
          || (StringSubstr(ObjName,0,3) == "SD_"    ) ) {
            ObjectDelete(ObjName);
        }
    }
}


void VLine(int i)
{
    string  Name    = "GN_"+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( Name, OBJ_TREND, 0, Time[i], 0, Time[i], 0.1);
    ObjectSet   ( Name, OBJPROP_COLOR,  DarkGray    );
    ObjectSet   ( Name, OBJPROP_STYLE,  STYLE_DOT   );
    ObjectSet   ( Name, OBJPROP_BACK,   true    );
}


void HLine( int i,  int iNew, double dPrice )
{
    string  Name    = "HL_"+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( Name, OBJ_TREND, 0, Time[i], dPrice, Time[iNew], dPrice);
    ObjectSet   ( Name, OBJPROP_COLOR,  Gray    );
    ObjectSet   ( Name, OBJPROP_STYLE,  STYLE_SOLID );
    ObjectSet   ( Name, OBJPROP_BACK,   false   );
    ObjectSet   ( Name, OBJPROP_RAY,    false   );
}

void HL_Modify( int i, int iNew, double dPrice  )
{
    string  Name    = "HL_" + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);
    ObjectMove  (Name, 1, Time[iNew], dPrice);
    return(0);
}

void SlopeLine( int no, int i, int j, double dPrice2, double dPrice1 )
{
    string  Name    = "HL_"+no+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( Name, OBJ_TREND, 0, Time[i], dPrice2, Time[j], dPrice1 );
    ObjectSet   ( Name, OBJPROP_COLOR,  Gray    );
    ObjectSet   ( Name, OBJPROP_STYLE,  STYLE_SOLID );
    ObjectSet   ( Name, OBJPROP_BACK,   false   );
    ObjectSet   ( Name, OBJPROP_RAY,    false   );
}


//-- Display of Phase --------------------------------------------------
#define POSITION0  5
#define POSITION1 10

string  sTucson     = "                               |TUCSON(range)";
string  sFlagstaff  = "                       |FLAGSTAFF";
string  sPhenix     = "                |PHENIX";
string  sYuma       = "            |YUMA";

void PutStr( int i, int iColor, string sTName )
{
    string  sName   = SHORT_NAME + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( sName, OBJ_TEXT, 0, 0, 0);
    if (bUp)    ObjectMove  ( sName, 0, Time[i], Low[i]  - POSITION0 * Point);
    else        ObjectMove  ( sName, 0, Time[i], High[i] + POSITION1 * Point);
    ObjectSetText(sName, sTName, 9, FONT, iColor    );
    VLine(i);
}


//-- Init --------------------------------------------------------------
void init_ARLib()
{
    //-- Display Info ----------------------
    PutDisp ( 2, "    (STD Edition)" );
}


//-- Standard Deviation Channels ---------------------------------------
#define STD.width   1.618
                //  Fibonacci number
                //  0.000   1.382   
                //  0.236   1.382
                //  0.382   1.618*
                //  0.500   2.000
                //  0.618*  2.618*
                //  0.764   4.236
                //  1.000*   

void SDC(   int i,  int iNew    )
{
    string  sStdCh  = "SD_" + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( sStdCh, OBJ_STDDEVCHANNEL, 0,
                    Time[i],    Open[i],    
                    Time[iNew],             Open[iNew]  );  
    ObjectSet   ( sStdCh, OBJPROP_DEVIATION,    STD.width   );
    ObjectSet   ( sStdCh, OBJPROP_COLOR,    Gray    );  
    ObjectSet   ( sStdCh, OBJPROP_STYLE,    STYLE_DOT   );
    ObjectSet   ( sStdCh, OBJPROP_RAY,      false   );  
    return(0);
}


void SDC_Modify( int i, int iNew )
{
    string  sStdCh  = "SD_" + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);
    ObjectMove  ( sStdCh, 1, Time[iNew],    Open[iNew]  );
    return(0);
}


//======================================================================
//== Phase function                                                   ==
//======================================================================
int IsPhenix( int i )
{
    bool    bPhenixUp   =    dFasterMA0 > dMediumMA0    //  Up trend
                          && dMediumMA0 > dSlowerMA0
                          && dFasterMA1 < dFasterMA0
                          && dFasterMA2 < dFasterMA1
                          && dSlowerMA1 < dSlowerMA0;
    bool    bPhenixDown =    dFasterMA0 < dMediumMA0    //  Down trend
                          && dMediumMA0 < dSlowerMA0
                          && dFasterMA1 > dFasterMA0
                          && dFasterMA2 > dFasterMA1
                          && dSlowerMA1 > dSlowerMA0;

    return (1*bPhenixUp + (-1)*bPhenixDown);
}


//======================================================================
//== Method function                                                  ==
//======================================================================

//-- Method : Winslow --------------------------------------------------
int IsWinslow( int i )
{
    //  Sorry, this is unlisted method (no release)
    return(0);
}


//-- Method : Divergence -----------------------------------------------
void IsDivergence( int i )
{
    if ( StochasDiverH(i) ) {
        BT_SigSend(OP_SELL, dBid, dBid+dSL*Point, dBid-dTP*Point, i, Divergence );
    }
    if ( StochasDiverL(i) ) {
        BT_SigSend(OP_BUY,  dAsk, dAsk-dSL*Point, dAsk+dTP*Point, i, Divergence );
    }
}


//-- Method : Scottsdale -----------------------------------------------
bool IsScottsdale(int i, bool bPreSigScottsdale)
{
    //    XgLX̊{IȌ80𒴂Ăwꂷxł낻
    //  邾낤ƂVOiA20Ăwꂷxł
    //  オ邾낤ƂVOiB㏸gh̃tFjbNX̂ƂA
    //  ꂷ][ŃS[fNX甃A_Egh
    //  ƂAꂷ][ŃfbhNX甄AꂼGg
    //  [̃`X
    double  dPK0    = iStochastic(NULL,0,30,10,10,MODE_SMA,0,MODE_MAIN,  i+1);
    double  dPK1    = iStochastic(NULL,0,30,10,10,MODE_SMA,0,MODE_MAIN,  i+2);
    double  dPD0    = iStochastic(NULL,0,30,10,10,MODE_SMA,0,MODE_SIGNAL,i+1);
    double  dPD1    = iStochastic(NULL,0,30,10,10,MODE_SMA,0,MODE_SIGNAL,i+2);
    if (!bPreSigScottsdale) {
        bPreSigScottsdale   = (bUp && dPK0 < 20.0) || (!bUp && dPK0 > 80.0);
    } else {
        if ( bUp && dPK0 > dPD0 && dPK1 < dPD1 ) {
            BT_SigSend(OP_BUY,  dAsk, dAsk-dSL*Point, dAsk+dTP*Point, i, Scottsdale );
            bPreSigScottsdale   = false;
        }
        if (!bUp && dPK0 < dPD0 && dPK1 > dPD1 ) {
            BT_SigSend(OP_SELL, dBid, dBid+dSL*Point, dBid-dTP*Point, i, Scottsdale );
            bPreSigScottsdale   = false;
        }
    //  WindowRedraw();
    }
    return(bPreSigScottsdale);
}


